function openSMTPSelect() {
  if (popupOn)
    return;

  // look for existing smtp window
  var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
  var e = watcher.getWindowByName("smtp", null);

  if (e) {
    // if exists, focus on it instead of opening new one
    e.focus();
  } else {
    try {
      // check if Thunderbird 1.0.* xul file exists
      var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var channel = ioService.newChannel('chrome://messenger/content/SmtpServerList.xul',null,null);
      var input = channel.open();
      input.available();
      input.close();
      var args = {result: false};
      window.openDialog('chrome://messenger/content/SmtpServerList.xul', 'smtp', 'modal,titlebar,chrome', args);
    } catch (ex) {
      // if exception, then open new custom xul file for Thunderbird 1.5+
      window.openDialog('chrome://buttons/content/smtpedit.xul', 'smtp', 'modal,titlebar,chrome', '');
    }
  }
}

// Thanks to Torisugari for this function!
function isInChromeAndEnabled(aResourceURI)
{
   try{
    var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
         .getService(Components.interfaces.nsIRDFService);
    var Container = Components.classes["@mozilla.org/rdf/container;1"]
         .getService(Components.interfaces.nsIRDFContainer);

    var chromeDS=RDFService.GetDataSource("rdf:chrome");
    var cResource=RDFService.GetResource("urn:mozilla:package:root");
    var disabledArc=RDFService
         .GetResource("http://www.mozilla.org/rdf/chrome#disabled");

    var target=RDFService.GetResource(aResourceURI);
    Container.Init(chromeDS,cResource);

    return (Container.IndexOf(target) > -1) &&
      !chromeDS.hasArcOut(target,disabledArc);
   }catch(e) {}
   return false;
}

function bSMTPDropInit() {
  var p = document.getElementById("SMTPDropDown");
  var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
  var servers = smtpService.smtpServers;
  var defaultSMTP = smtpService.defaultServer;
  var serverCount = servers.Count();
  var ssunInstalled = isInChromeAndEnabled("urn:mozilla:package:ssun");

  var showUsername = false;
  var useAlias = false;
  var hideUsername = true;

  if (ssunInstalled) {
    useAlias = nsPreferences.getBoolPref("ssun.showalias", true);
    showUsername = nsPreferences.getBoolPref("ssun.showusername", true);
    hideUsername = nsPreferences.getBoolPref("ssun.hideusername", true);
  }

  var server;
  var myKey;

  for (var i = 0; i < serverCount; ++i) {
    server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
    var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
    menuitem.setAttribute("value", server.key);

    var hostname = server.hostname;
    var port = "";

    if (server.port)
      port = ":" + server.port;

    var alias = "";
    if (useAlias) {
      alias = nsPreferences.getLocalizedUnicharPref("ssun." + server.key + ".alias", "");
      if (alias) {
        hostname = alias;
      } else {
        hostname += port;
      }
    } else {
      hostname += port;
    }

    if (showUsername && (!useAlias || (useAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
      hostname += " (" + server.username + ")";

    menuitem.setAttribute("label", hostname);
    menuitem.setAttribute("type", "radio");

    if (server.key == defaultSMTP.key) {
      menuitem.setAttribute("checked", true);
    }

    menuitem.setAttribute("tooltiptext", server.hostname);
    menuitem.setAttribute("oncommand", "bSMTPSelectDefault(this);");
    p.appendChild(menuitem);
  }
}

function bSMTPSelectDefault(p) {
  var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
  if (p.value != smtpService.defaultServer.key) {
    smtpService.defaultServer = smtpService.getServerByKey(p.value);
  }
  popupOn = true;
}

  /* commenting out
function bUpdateUndoButtons(manager) {
  var bUndoCmd = document.getElementById("cmd_buttons_undo");
  var bRedoCmd = document.getElementById("cmd_buttons_redo");

  if(manager.numberOfUndoItems) {
    bEnableElem(bUndoCmd);
  } else {
    bDisableElem(bUndoCmd);
  }

  if(manager.numberOfRedoItems) {
    bEnableElem(bRedoCmd);
  } else {
    bDisableElem(bRedoCmd);
  }
}

var bTransactionListener = {
  willDo: function (aTxmgr, aTxn) {},
  didDo : function (aTxmgr, aTxn) {
    bUpdateUndoButtons(aTxmgr);
  },
  willUndo: function (aTxmgr, aTxn) {},
  didUndo : function (aTxmgr, aTxn) {
    bUpdateUndoButtons(aTxmgr);
  },
  willRedo: function (aTxmgr, aTxn) {},
  didRedo : function (aTxmgr, aTxn) {
    bUpdateUndoButtons(aTxmgr);
  },
  didMerge     : function (aTxmgr, aTxn) {},
  didBeginBatch  : function (aTxmgr, aTxn) {},
  didEndBatch  : function (aTxmgr, aTxn) {},
  willMerge    : function (aTxmgr, aTxn) {},
  willBeginBatch : function (aTxmgr, aTxn) {},
  willEndBatch   : function (aTxmgr, aTxn) {}
};
*/
